﻿'imports some needed libraries dont forget to also reference the dlls in your solution

Imports System.ComponentModel
Imports System.Runtime.InteropServices
Imports AudioSwitcher
Imports Microsoft.Win32
Public Class Form1
    'create a sound device to use
    Public device As AudioSwitcher.AudioApi.CoreAudio.CoreAudioDevice
    Public strappdata As String
    'hide the close button on the form
    Private Const CP_NOCLOSE_BUTTON As Integer = &H200
    Protected Overloads Overrides ReadOnly Property CreateParams() As CreateParams
        'make the close button dissapear
        Get
            Dim myCp As CreateParams = MyBase.CreateParams
            myCp.ClassStyle = myCp.ClassStyle Or CP_NOCLOSE_BUTTON
            Return myCp
        End Get
    End Property


    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'add an event handler to catch the logon and unlock events
        AddHandler Microsoft.Win32.SystemEvents.SessionSwitch, AddressOf SessionSwitch
        'get the appdata folder for teh user
        strappdata = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData)
        'get the default playback device usually the master volume when no other devices are present
        device = New AudioApi.CoreAudio.CoreAudioController().DefaultPlaybackDevice
        'print info on a label on the form and resize properly
        Label1.Text = "Current volume level of: " & device.FullName.ToString
        lblvolume.Left = Label1.Left + Label1.Width + 10
        HScrollBar1.Left = lblvolume.Left + lblvolume.Width + 10
        btnmute.Left = HScrollBar1.Left
        Button1.Left = btnmute.Left + btnmute.Width - Button1.Width
        Me.Width = HScrollBar1.Left + HScrollBar1.Width + 25
        'check for setting file and if its present read values from it to set the master volume
        If System.IO.File.Exists(strappdata.ToString & "\SetVolume\Volume.ini") = True Then
            Dim sReader As System.IO.StreamReader = Nothing
            Dim strRead() As String = Nothing
            sReader = New IO.StreamReader(strappdata.ToString & "\SetVolume\Volume.ini")
            While sReader.Peek <> -1
                strRead = Split(sReader.ReadLine, "=")
                If strRead(0).ToString = "Volume" Then
                    'set volume
                    device.Volume = Val(strRead(1).ToString)
                End If
                If strRead(0).ToString = "Mute" Then
                    'set mute state
                    If strRead(1).ToString.ToUpper = "FALSE" Then
                        device.Mute(False)
                    End If
                    If strRead(1).ToString.ToUpper = "TRUE" Then
                        device.Mute(True)
                    End If
                End If
            End While
            sReader.Close()
        Else
            'create the appdata folder if tit is not there to save ini file and store current volume settings
            If System.IO.Directory.Exists(strappdata.ToString & "\SetVolume") = False Then
                System.IO.Directory.CreateDirectory(strappdata.ToString & "\SetVolume")
                System.IO.File.Create(strappdata.ToString & "\SetVolume\Volume.ini").Close()
                Dim sWriter As System.IO.StreamWriter = Nothing
                sWriter = New IO.StreamWriter(strappdata.ToString & "\SetVolume\Volume.ini", False)
                sWriter.WriteLine("Volume=" & device.Volume.ToString)
                sWriter.WriteLine("Mute=" & device.IsMuted.ToString)
                sWriter.Close()
            Else
                'store settings in ini file
                System.IO.File.Create(strappdata.ToString & "\SetVolume\Volume.ini").Close()
                Dim sWriter As System.IO.StreamWriter = Nothing
                sWriter = New IO.StreamWriter(strappdata.ToString & "\SetVolume\Volume.ini", False)
                sWriter.WriteLine("Volume=" & device.Volume.ToString)
                sWriter.WriteLine("Mute=" & device.IsMuted.ToString)
                sWriter.Close()
            End If


        End If
        'set lebels on primary form
        'change value of scrollbar to show current volume level
        lblvolume.Text = device.Volume & " %"
        HScrollBar1.Value = device.Volume
        If device.IsMuted = True Then
            lblmute.Text = "Muted"
            btnmute.Text = "Unmute"
        Else
            lblmute.Text = "Unmuted"
            btnmute.Text = "Mute"
        End If
        'set interval of timer to 30 seconds and let it write the ini file every 30 seconds to preserve changes.
        Timer1.Interval = 30000
        Timer1.Enabled = True


    End Sub
    Private Sub SessionSwitch(ByVal sender As Object, ByVal e As Microsoft.Win32.SessionSwitchEventArgs)

        'check for event logon or unlock
        If e.Reason = e.Reason = SessionSwitchReason.SessionLogon Or e.Reason = SessionSwitchReason.SessionUnlock Then
            'diabel timer so settings cannot be written and prevent sound setting mechanism to mess up user settings
            Timer1.Enabled = False
            'set volume to 1 and to 0
            device.Volume = 1
            device.Volume = 0
            For a = 0 To 10
                'make the device go to mute state by reapeating the setting (it needs to be repeated to work)
                'device will always start in mute state to prevent loud noises.
                device.Mute(False)
                device.Mute(True)
                Threading.Thread.Sleep(5)
            Next a
            'start reading user settings
            Dim sReader As System.IO.StreamReader = Nothing
            Dim strRead() As String = Nothing
            sReader = New IO.StreamReader(strappdata.ToString & "\SetVolume\Volume.ini")
            While sReader.Peek <> -1
                strRead = Split(sReader.ReadLine, "=")
                For i = 0 To 25 'repest settings 25 times
                    'check for volume
                    If strRead(0).ToString = "Volume" Then
                        Threading.Thread.Sleep(5)
                        'decrease volume by 1 
                        device.Volume = Val(strRead(1).ToString) - 1
                        Threading.Thread.Sleep(5)
                        'set volume to desired level
                        device.Volume = Val(strRead(1).ToString)
                    End If
                    If strRead(0).ToString = "Mute" Then
                        'set mute sate 
                        If strRead(1).ToString.ToUpper = "FALSE" Then
                            device.Mute(False)
                        End If
                        If strRead(1).ToString.ToUpper = "TRUE" Then
                            device.Mute(True)
                        End If
                    End If
                Next i
            End While
            sReader.Close()
        End If
        'enable timer to save user changes
        Timer1.Enabled = True

    End Sub
    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub


    Private Sub btnmute_Click(sender As Object, e As EventArgs) Handles btnmute.Click
        'add mute button actions i know GOTO but it's so easy :) could have used a case instead.
        If device.IsMuted = False Then
            device.Mute(True)
            lblmute.Text = "Muted"
            btnmute.Text = "Unmute"
            GoTo 1
        End If
        If device.IsMuted = True Then
            device.Mute(False)
            lblmute.Text = "Unmuted"
            btnmute.Text = "Mute"
            GoTo 1
        End If
1:
        'write new state to ini
        Dim sWriter As System.IO.StreamWriter = Nothing
        sWriter = New IO.StreamWriter(strappdata.ToString & "\SetVolume\Volume.ini", False)
        sWriter.WriteLine("Volume=" & device.Volume.ToString)
        sWriter.WriteLine("Mute=" & device.IsMuted.ToString)
        sWriter.Close()


    End Sub


    Private Sub HScrollBar1_ValueChanged(sender As Object, e As EventArgs) Handles HScrollBar1.ValueChanged
        'handle scrollbar and settings saving
        Try
            Dim sWriter As System.IO.StreamWriter = Nothing
            sWriter = New IO.StreamWriter(strappdata.ToString & "\SetVolume\Volume.ini", False)
            device.Volume = HScrollBar1.Value
            lblvolume.Text = device.Volume & " %"
            sWriter.WriteLine("Volume=" & device.Volume.ToString)
            sWriter.WriteLine("Mute=" & device.IsMuted.ToString)
            If device.IsMuted = True Then
                lblmute.Text = "Muted"
                btnmute.Text = "Unmute"
            Else
                lblmute.Text = "Unmuted"
                btnmute.Text = "Mute"
            End If
            sWriter.Close()
        Catch
        End Try
    End Sub

    Private Sub NotifyIcon1_MouseDoubleClick(sender As Object, e As MouseEventArgs) Handles NotifyIcon1.MouseDoubleClick
        'set low interval so when the form becomes visible it will also show the changes made trough the windows sound control
        Timer1.Interval = 300
        Timer1.Enabled = True
        Me.Show()
        Try
            Me.WindowState = FormWindowState.Normal
            If device.IsMuted = True Then
                lblmute.Text = "Unmuted"
                btnmute.Text = "Mute"
            Else
                lblmute.Text = "Muted"
                btnmute.Text = "Unmute"
            End If
        Catch
        End Try
    End Sub

    Private Sub Button1_Click_1(sender As Object, e As EventArgs) Handles Button1.Click
        'hide the program again 
        Me.Hide()
        Me.ShowInTaskbar = False
        Timer1.Interval = 45000
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        'save settings in the background every 45 seconds
        lblvolume.Text = device.Volume & " %"
        HScrollBar1.Value = device.Volume
        If device.IsMuted = True Then
            lblmute.Text = "Muted"
            btnmute.Text = "Unmute"
        Else
            lblmute.Text = "Unmuted"
            btnmute.Text = "Mute"
        End If
        Dim sWriter As System.IO.StreamWriter = Nothing
        sWriter = New IO.StreamWriter(strappdata.ToString & "\SetVolume\Volume.ini", False)
        sWriter.WriteLine("Volume=" & device.Volume.ToString)
        sWriter.WriteLine("Mute=" & device.IsMuted.ToString)
        sWriter.Close()
        'make me jump in font of all windows when i am visible
        If Me.Visible = True Then Me.Activate()

    End Sub

    Private Sub AboutToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AboutToolStripMenuItem.Click
        'handle about menu item
        Form2.ShowDialog()
    End Sub

    Private Sub ExitProgramToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ExitProgramToolStripMenuItem.Click
        'handle exit menu item
        Me.Close()
    End Sub


    Private Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Me.Closing
        'save settings befor closing the app
        Try
            Dim sWriter As System.IO.StreamWriter = Nothing
            sWriter = New IO.StreamWriter(strappdata.ToString & "\SetVolume\Volume.ini", False)
            device.Volume = HScrollBar1.Value
            lblvolume.Text = device.Volume & " %"
            sWriter.WriteLine("Volume=" & device.Volume.ToString)
            sWriter.WriteLine("Mute=" & device.IsMuted.ToString)
            If device.IsMuted = True Then
                lblmute.Text = "Muted"
                btnmute.Text = "Unmute"
            Else
                lblmute.Text = "Unmuted"
                btnmute.Text = "Mute"
            End If
            sWriter.Close()
        Catch
        End Try
    End Sub

    Private Sub OpenAppDataToolStripMenuItem1_Click(sender As Object, e As EventArgs) Handles OpenAppDataToolStripMenuItem1.Click
        'handle open appdata menu item
        Process.Start("c:\windows\explorer.exe", strappdata.ToString)
    End Sub

    Private Sub AboutToolStripMenuItem1_Click(sender As Object, e As EventArgs) Handles AboutToolStripMenuItem1.Click
        Form2.StartPosition = FormStartPosition.CenterScreen
        Form2.ShowDialog()
        Me.Activate()
    End Sub

    Private Sub ShowFormToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ShowFormToolStripMenuItem.Click
        Timer1.Interval = 300
        Timer1.Enabled = True
        Me.Show()
        ' Me.ShowInTaskbar = True
        Me.WindowState = FormWindowState.Normal
        If device.IsMuted = True Then
            lblmute.Text = "Unmuted"
            btnmute.Text = "Mute"
        Else
            lblmute.Text = "Muted"
            btnmute.Text = "Unmute"
        End If
    End Sub
End Class
